Subject: Re: bug#66755: 30.0.50; how do i lookup a key but also respect key translations?

From: Stefan Kangas <[email-masked]>
Date: Wed, 10 Jan 2024 10:00:29 -0800

Eli Zaretskii <[email-masked]> writes:

>> From: StrawberryTea <[email-masked]>
>> Date: Wed, 25 Oct 2023 22:57:58 -0500
>>
>>
>> Hello. So I am trying to define a function which obtains the command
>> that would be called if 'corfu-mode' was not enabled:
>>
>> (defun +corfu--get-passthrough-command ()
>>   (keymap-lookup
>>    (thread-last
>>      (current-active-maps t)
>>      (delq corfu-map)
>>      (delq (and (featurep 'evil)
>>                 (evil-get-auxiliary-keymap corfu-map evil-state))))
>>    (key-description (this-command-keys-vector))))
>>
>> But the issue is basically that
>>
>> (keymap-lookup (current-active-maps t)
>>     (key-description (vector 'backspace)))
>>
>> returns nil whereas
>>
>> (keymap-lookup (current-active-maps t) (key-description (vector ?\C-?)))
>>
>> returns 'lispy-delete-backward' which is the command I actually want
>> returned. When I run 'describe-key-briefly' and type <backspace>, I get
>>
>> DEL (translated from <backspace>) runs the command lispy-delete-backward
>>
>> but I don't know how to look up that translation from Elisp. I looked at
>> the code for 'help.el' and found the above description comes from
>> 'read-key-sequence' returning 'C-?' and 'this-single-command-raw-keys'
>> returning '[backspace]' but 'read-key-sequence' is defined in C and I
>> don't know how trigger it's translation logic programmatically from
>> Elisp.
>
> Perhaps Stefan (CC'ed) could help you.
>
> Btw, this kind of questions should be posted to
> [email-masked], not here.

That sounds like this is not a bug, so I'm closing the bug report.